#include <stdio.h>
#include <stdlib.h>
#include "compare.h"
#include "randdat.h"
#include "indexof.h"
#include "indexof_linear.h"
#include "stampa_risultato.h"
#define num_elementi 1024

int main()
{
 printf(" programma ricerca_binaria_numeroesterno.c \n");
 printf(" confronta l'algoritmo di ricerca binaria \n");
 printf(" passi k 1<=k<=log2 (N)\n");
 printf(" con quello di ricerca lineare \n");
 printf(" passi k 1<=k<=N \n");
        int  i;
        int num_operazioni = 0;
        int num, min, max;
        int array[num_elementi];
        int elemento_ricercato;
        //Questo codice serve per modificare il seed del generatore di numeri random.
        printf("\n Scrivi quanti elementi devono essere generati random max %d \n", num_elementi);
        scanf("%d", &num);
        printf("\n Inserire valore minimo  \n");
        scanf("%d", &min);
        printf("\n Inserire valore massimo \n");
        scanf("%d", &max);
        randdat(array, max,  min, num);
        printf("Valori generati \n");
        // ordinare vettore
        qsort (array, num, sizeof(int), compare);
        for (i = 0; i < num; i++) {
            printf(" %d \t ", array[i]);
        }
        //Avvio la ricerca con la ricerca binaria.
        //Chiedo un elemento da ricercare nel range dell'array.
        printf("\n Scrivi un elemendo da ricercare.  \n");
        scanf("%d", &elemento_ricercato);
        printf("\n PARTENZA ALGORITMO RICERCA BINARIA \n");
        int k = indexof(elemento_ricercato,array,0,num, &num_operazioni);
        stampa_risultato(k,num_operazioni);
        //Azzero i contatori per eseguire lo stesso programma con l'algoritmo lineare.
        printf("\n PARTENZA ALGORITMO RICERCA LINEARE \n");
        num_operazioni = 0;
        k = -1;
        k = indexof_linear(elemento_ricercato,array,num, &num_operazioni);
        stampa_risultato(k,num_operazioni);
        return 0;
}

